package org.eclipse.swt.snippets;

import java.io.File;

import org.eclipse.swt.SWT;
import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.DropTargetEvent;
import org.eclipse.swt.dnd.FileTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import de.wim.outldd.OutlookDD;

public class Snippet185 {

	public static void main(String[] args) {
		
		Display display = new Display();
		Shell shell = new Shell(display);
		shell.setLayout(new FillLayout());
		try {
			OutlookDD.init(OutlookDD.MODE_TEMP_FILES);
		} catch (Exception e) {
			e.printStackTrace();
		}
		Composite cmp = new Composite(shell, SWT.NONE);
		cmp.setLayout(new GridLayout());
		Label label = new Label(cmp, SWT.BORDER);
		label.setText("Drop here");
		org.eclipse.swt.dnd.DropTarget dropTarget = new org.eclipse.swt.dnd.DropTarget(label, DND.DROP_COPY
				| DND.DROP_DEFAULT );
		dropTarget.setTransfer(new Transfer[] {FileTransfer.getInstance()});
		
		dropTarget.addDropListener(new org.eclipse.swt.dnd.DropTargetAdapter() {
			@Override
			public void dragEnter(DropTargetEvent event) {
				super.dragEnter(event);
			}
			@Override
			public void dragOver(DropTargetEvent event) {
				event.detail = DND.DROP_COPY;
				super.dragOver(event);
			}
			@Override
			public void drop(DropTargetEvent event) {
				String[] fileList;
				if (event.data instanceof String) {
					fileList = new String[] { (String) event.data };
				} else {
					fileList = (String[]) event.data;

				}
				for (String fname : fileList) {
					File file = new File(fname);
					System.out.println("file=" + file + ", exists=" + file.exists() + ", fsize=" + file.length());
				}

				super.drop(event);
			}
		});  
		shell.setSize(300, 150);
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}
}
